## goldendict-webengine 22.11.24

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.23)

# Experimental Cmake build only supposed to be used by dev
# Qt6.4+ only
# LINUX, APPLE and MSVC are used to detect system

option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)

# Remove this once cmake 5.25 becomes minimum version
if(UNIX AND NOT APPLE)
    set(LINUX TRUE)
endif()

if (APPLE)
    add_subdirectory(eb)
endif ()

project(goldendict
        VERSION 22.11.20
        LANGUAGES CXX C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#### Importing Libraries

find_package(Qt6 REQUIRED COMPONENTS
        Concurrent
        Core5Compat
        Help
        LinguistTools
        Multimedia
        WebEngineWidgets
        Widgets
        Svg
        Xml
        )

if (APPLE)
    find_library(CARBON_LIBRARY Carbon REQUIRED)
endif ()

if (UNIX)
    # Provided by Cmake
    find_package(ZLIB REQUIRED)
    find_package(BZip2 REQUIRED)

    # PkgConfig only packages
    find_package (PkgConfig REQUIRED)
    pkg_check_modules (PKGCONFIG_DEPS IMPORTED_TARGET
            hunspell
            lzo2
            opencc
            vorbis # .ogg
            vorbisfile
            liblzma
            libzstd
            )
    if (WITH_FFMPEG_PLAYER)
        pkg_check_modules(FFMPEG REQUIRED IMPORTED_TARGET
                libavcodec
                libavformat
                libavutil
                libswresample
                )
    endif ()
endif ()

if(LINUX)
    find_package(X11 REQUIRED)
    pkg_check_modules (LIBXTST IMPORTED_TARGET xtst)

    add_library(libeb SHARED IMPORTED)
    set_target_properties(libeb PROPERTIES IMPORTED_LOCATION /usr/lib/libeb.so)
    set_target_properties(libeb PROPERTIES INCLUDE_DIRECTORIES /usr/include/)
endif()

#### Compile time files and preprocessor flags

# Obtain git commit hash
execute_process(
        COMMAND git rev-parse --short=8 HEAD
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
        OUTPUT_VARIABLE GIT_HASH
        OUTPUT_STRIP_TRAILING_WHITESPACE
)

string(TIMESTAMP date_for_version_file) # note: this variable is cached for every run, but for user installation, this doesn't matter much
configure_file(version.txt.in ${CMAKE_SOURCE_DIR}/version.txt)

# hack -> this string will be compared with another string, thus having surrounding " "
add_compile_definitions(PROGRAM_VERSION="${PROJECT_VERSION}")

add_compile_definitions(CMAKE_USED_HACK) # temporal hack to avoid breaking qmake build
add_compile_definitions(
        MAKE_ZIM_SUPPORT
        MAKE_QTMULTIMEDIA_PLAYER
        MAKE_CHINESE_CONVERSION_SUPPORT
)

if (WITH_FFMPEG_PLAYER)
    add_compile_definitions(MAKE_FFMPEG_PLAYER)
endif ()

if(LINUX)
    add_compile_definitions(HAVE_X11)
endif()

if(MSVC)
    add_compile_definitions(NO_EPWING_SUPPORT)
endif()

#### Sources Files

set(QRC_RESOURCES
        flags.qrc
        resources.qrc
        scripts.qrc
        )

set(UI_SRC
        about.ui
        articleview.ui
        authentication.ui
        chineseconversion.ui
        dictgroupwidget.ui
        dictheadwords.ui
        dictinfo.ui
        editdictionaries.ui
        fulltextsearch.ui
        groups.ui
        initializing.ui
        mainwindow.ui
        options.ui
        orderandprops.ui
        preferences.ui
        scanflag.ui
        scanpopup.ui
        sources.ui
        )

set(EPWING_SUPPORT_SRC
        epwing.cc
        epwing.hh
        epwing_book.cc
        epwing_book.hh
        epwing_charmap.cc
        epwing_charmap.hh
        )

if (APPLE)
    set(MAC_SRC
            machotkeywrapper.mm
            macmouseover.hh
            macmouseover.mm
            speechclient.hh
            speechclient_mac.mm
            texttospeechsource.cc
            texttospeechsource.hh
            texttospeechsource.ui
            )
endif ()

if(MSVC)
    set(WIN_SRC
            guids.c # ONLY RELATED TO TTS
            speechclient.hh
            speechclient_win.cc
            speechhlp.cc
            speechhlp.hh
            texttospeechsource.cc
            texttospeechsource.hh
            texttospeechsource.ui
            )
endif()

if(WITH_FFMPEG_PLAYER)
    set(FFMPEG_SUPPORT_SRC
            ffmpegaudio.cc
            ffmpegaudio.hh
            ffmpegaudioplayer.hh
            )
endif()

set(PROJECT_SOURCES
        ${UI_SRC}
        ${MAC_SRC}
        ${WIN_SRC}
        ${QRC_RESOURCES}
        ${EPWING_SUPPORT_SRC}
        ${FFMPEG_SUPPORT_SRC}
        aard.cc
        aard.hh
        about.cc
        about.hh
        ankiconnector.cpp
        ankiconnector.h
        article_inspect.cpp
        article_inspect.h
        article_maker.cc
        article_maker.hh
        article_netmgr.cc
        article_netmgr.hh
        articleview.cc
        articleview.hh
        articlewebpage.cpp
        articlewebpage.h
        articlewebview.cc
        articlewebview.hh
        atomic_rename.cc
        atomic_rename.hh
        audiolink.cc
        audiolink.hh
        audiooutput.cpp
        audiooutput.h
        audioplayerfactory.cc
        audioplayerfactory.hh
        audioplayerinterface.hh
        base/globalregex.cc
        base/globalregex.hh
        belarusiantranslit.cc
        belarusiantranslit.hh
        bgl.cc
        bgl.hh
        bgl_babylon.cc
        bgl_babylon.hh
        btreeidx.cc
        btreeidx.hh
        chinese.cc
        chinese.hh
        chineseconversion.cc
        chineseconversion.hh
        chunkedstorage.cc
        chunkedstorage.hh
        config.cc
        config.hh
        country.cc
        country.hh
        decompress.cc
        decompress.hh
        delegate.cc
        delegate.hh
        dictdfiles.cc
        dictdfiles.hh
        dictheadwords.cc
        dictheadwords.hh
        dictinfo.cc
        dictinfo.hh
        dictionary.cc
        dictionary.hh
        dictionarybar.cc
        dictionarybar.hh
        dictserver.cc
        dictserver.hh
        dictspanewidget.hh
        dictzip.c
        dictzip.h
        dsl.cc
        dsl.hh
        dsl_details.cc
        dsl_details.hh
        editdictionaries.cc
        editdictionaries.hh
        ex.hh
        externalaudioplayer.cc
        externalaudioplayer.hh
        externalviewer.cc
        externalviewer.hh
        extlineedit.cc
        extlineedit.hh
        favoritespanewidget.cc
        favoritespanewidget.hh
        file.cc
        file.hh
        filetype.cc
        filetype.hh
        fixx11h.h
        folding.cc
        folding.hh
        forvo.cc
        forvo.hh
        fsencoding.cc
        fsencoding.hh
        ftshelpers.cc
        ftshelpers.hh
        fulltextsearch.cc
        fulltextsearch.hh
        gdappstyle.cc
        gdappstyle.hh
        gddebug.cc
        gddebug.hh
        german.cc
        german.hh
        gestures.cc
        gestures.hh
        globalbroadcaster.cpp
        globalbroadcaster.h
        gls.cc
        gls.hh
        greektranslit.cc
        greektranslit.hh
        groupcombobox.cc
        groupcombobox.hh
        groups.cc
        groups.hh
        groups_widgets.cc
        groups_widgets.hh
        headwordsmodel.cpp
        headwordsmodel.h
        helpwindow.cc
        helpwindow.hh
        history.cc
        history.hh
        historypanewidget.cc
        historypanewidget.hh
        hotkeyedit.cc
        hotkeyedit.hh
        hotkeywrapper.cc
        hotkeywrapper.hh
        htmlescape.cc
        htmlescape.hh
        hunspell.cc
        hunspell.hh
        iconv.cc
        iconv.hh
        iframeschemehandler.cpp
        iframeschemehandler.h
        inc_case_folding.hh
        inc_diacritic_folding.hh
        indexedzip.cc
        indexedzip.hh
        initializing.cc
        initializing.hh
        instances.cc
        instances.hh
        keyboardstate.cc
        keyboardstate.hh
        langcoder.cc
        langcoder.hh
        language.cc
        language.hh
        loaddictionaries.cc
        loaddictionaries.hh
        lsa.cc
        lsa.hh
        main.cc
        mainstatusbar.cc
        mainstatusbar.hh
        maintabwidget.cc
        maintabwidget.hh
        mainwindow.cc
        mainwindow.hh
        mdictparser.cc
        mdictparser.hh
        mdx.cc
        mdx.hh
        mediawiki.cc
        mediawiki.hh
        mruqmenu.cc
        mruqmenu.hh
        multimediaaudioplayer.cc
        multimediaaudioplayer.hh
        mutex.cc
        mutex.hh
        orderandprops.cc
        orderandprops.hh
        parsecmdline.cc
        parsecmdline.hh
        preferences.cc
        preferences.hh
        processwrapper.cc
        processwrapper.hh
        programs.cc
        programs.hh
        resourceschemehandler.cpp
        resourceschemehandler.h
        ripemd.cc
        ripemd.hh
        romaji.cc
        romaji.hh
        russiantranslit.cc
        russiantranslit.hh
        sapi.hh
        scanflag.cc
        scanflag.hh
        scanpopup.cc
        scanpopup.hh
        sdict.cc
        sdict.hh
        searchpanewidget.hh
        slob.cc
        slob.hh
        sounddir.cc
        sounddir.hh
        sources.cc
        sources.hh
        sphelper.hh
        splitfile.cc
        splitfile.hh
        sptr.hh
        stardict.cc
        stardict.hh
        stylescombobox.cc
        stylescombobox.hh
        termination.cc
        termination.hh
        thirdparty/qtsingleapplication/src/qtlocalpeer.cpp
        thirdparty/qtsingleapplication/src/qtlocalpeer.h
        thirdparty/qtsingleapplication/src/qtsingleapplication.cpp
        thirdparty/qtsingleapplication/src/qtsingleapplication.h
        thirdparty/qtsingleapplication/src/qtsinglecoreapplication.cpp
        thirdparty/qtsingleapplication/src/qtsinglecoreapplication.h
        tiff.cc
        tiff.hh
        translatebox.cc
        translatebox.hh
        transliteration.cc
        transliteration.hh
        treeview.cc
        treeview.hh
        ufile.cc
        ufile.hh
        utf8.cc
        utf8.hh
        utils.cc
        utils.hh
        voiceengines.cc
        voiceengines.hh
        webmultimediadownload.cc
        webmultimediadownload.hh
        website.cc
        website.hh
        weburlrequestinterceptor.cpp
        weburlrequestinterceptor.h
        wildcard.cc
        wildcard.hh
        wordfinder.cc
        wordfinder.hh
        wordlist.cc
        wordlist.hh
        wstring.hh
        wstring_qt.cc
        wstring_qt.hh
        xdxf.cc
        xdxf.hh
        xdxf2html.cc
        xdxf2html.hh
        zim.cc
        zim.hh
        zipfile.cc
        zipfile.hh
        zipsounds.cc
        zipsounds.hh
        )

qt_add_executable(${CMAKE_PROJECT_NAME}
        MANUAL_FINALIZATION
        ${PROJECT_SOURCES})

target_include_directories(${CMAKE_PROJECT_NAME} PUBLIC
        ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src)

if(MSVC)
    add_compile_definitions(INCLUDE_LIBRARY_PATH)
    target_include_directories(${CMAKE_PROJECT_NAME} PUBLIC
            ${CMAKE_SOURCE_DIR}/winlibs/include/
            )
endif()

target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE
        Qt6::Xml
        Qt6::Concurrent
        Qt6::Core5Compat
        Qt6::Help
        Qt6::Multimedia
        Qt6::WebEngineWidgets
        Qt6::Widgets
        Qt6::Svg
        )

if(APPLE)
    target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE eb)
endif()

if(UNIX)
    target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE
            # pkg-config packages need manually link
            PkgConfig::PKGCONFIG_DEPS

            BZip2::BZip2
            ZLIB::ZLIB #hidden requirement of dsl_details.cc and more?
            )
endif()

if(MSVC)
    file(GLOB WINLIBS_FILES "${CMAKE_SOURCE_DIR}/winlibs/lib/msvc/*.lib")
    foreach(A_WIN_LIB ${WINLIBS_FILES})
        target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE ${A_WIN_LIB})
    endforeach()
endif()


if(LINUX)
    target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE libeb X11 PkgConfig::LIBXTST)
endif ()

if(APPLE)

## goldendict-webengine 22.11.24-alpha.221205.45d740a5

=== debian/changelog ===
goldendict-webengine (22.11.24-alpha.221205.45d740a5-2) unstable; urgency=medium

  * Source-only upload.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Dec 2022 15:27:27 -0500

goldendict-webengine (22.11.24-alpha.221205.45d740a5-1) unstable; urgency=medium

  * Initial release. (Closes: #1024862)
  * debian/copyright: Update icons copyright information.

 -- Boyuan Yang <byang@debian.org>  Tue, 06 Dec 2022 16:12:46 -0500

## goldendict-webengine 22.12.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,18 @@
 # LINUX, APPLE and MSVC are used to detect system
 
 option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
-
+option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
 # Remove this once cmake 5.25 becomes minimum version
 if(UNIX AND NOT APPLE)
     set(LINUX TRUE)
 endif()
 
 if (APPLE)
-    add_subdirectory(eb)
+    if(WITH_EPWING_SUPPORT)
+    add_subdirectory(thirdparty/eb)
+    endif()
+
+    include_directories(/usr/local/include /opt/homebrew/include)
 endif ()
 
 project(goldendict
@@ -76,9 +80,12 @@
     find_package(X11 REQUIRED)
     pkg_check_modules (LIBXTST IMPORTED_TARGET xtst)
 
-    add_library(libeb SHARED IMPORTED)
-    set_target_properties(libeb PROPERTIES IMPORTED_LOCATION /usr/lib/libeb.so)
-    set_target_properties(libeb PROPERTIES INCLUDE_DIRECTORIES /usr/include/)
+    if(WITH_EPWING_SUPPORT)
+        add_subdirectory(thirdparty/eb EXCLUDE_FROM_ALL)
+    endif()
+    # add_library(libeb SHARED IMPORTED)
+    # set_target_properties(libeb PROPERTIES IMPORTED_LOCATION /usr/lib/libeb.so)
+    # set_target_properties(libeb PROPERTIES INCLUDE_DIRECTORIES /usr/include/)
 endif()
 
 #### Compile time files and preprocessor flags
@@ -144,7 +151,7 @@
         scanpopup.ui
         sources.ui
         )
-
+if(WITH_EPWING_SUPPORT)
 set(EPWING_SUPPORT_SRC
         epwing.cc
         epwing.hh
@@ -153,6 +160,9 @@
         epwing_charmap.cc
         epwing_charmap.hh
         )
+else()
+    add_compile_definitions(NO_EPWING_SUPPORT)
+endif()        
 
 if (APPLE)
     set(MAC_SRC
@@ -471,6 +481,9 @@
     target_include_directories(${CMAKE_PROJECT_NAME} PUBLIC
             ${CMAKE_SOURCE_DIR}/winlibs/include/
             )
+
+    set_property(TARGET ${CMAKE_PROJECT_NAME} PROPERTY 
+    MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")            
 endif()
 
 target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE
@@ -485,29 +498,10 @@
         )
 
 if(APPLE)
+    if(WITH_EPWING_SUPPORT)
     target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE eb)
+    endif()
 endif()
 
 if(UNIX)
-    target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE
-            # pkg-config packages need manually link
-            PkgConfig::PKGCONFIG_DEPS
-
-            BZip2::BZip2
-            ZLIB::ZLIB #hidden requirement of dsl_details.cc and more?
-            )
-endif()
-
-if(MSVC)
-    file(GLOB WINLIBS_FILES "${CMAKE_SOURCE_DIR}/winlibs/lib/msvc/*.lib")
-    foreach(A_WIN_LIB ${WINLIBS_FILES})
-        target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE ${A_WIN_LIB})
-    endforeach()
-endif()
-
-
-if(LINUX)
-    target_link_libraries(${CMAKE_PROJECT_NAME} PRIVATE libeb X11 PkgConfig::LIBXTST)
-endif ()
-
-if(APPLE)
+    target_include_directories(${CMAKE_PROJECT_NAME} PRIVATE

=== debian/changelog ===
goldendict-webengine (22.12.20-1) unstable; urgency=medium

  * New upstream release 22.12.22-WinderSolstice.221220.311d08c6.
  * debian/patches: Add patch to disable new version check by default.

 -- Boyuan Yang <byang@debian.org>  Wed, 21 Dec 2022 16:32:44 -0500

=== debian/control ===
Source: goldendict-webengine
Priority: optional
Section: utils
Maintainer: Boyuan Yang <byang@debian.org>
Standards-Version: 4.6.1
Build-Depends:
 debhelper-compat (= 13),
 libao-dev,
 libavformat-dev,
 libavutil-dev,
 libbz2-dev,
 libeb16-dev,
 libhunspell-dev,
 libjs-jquery,
 liblzma-dev,
 liblzo2-dev,
 libopencc-dev (>= 1.1),
 libphonon4qt5-dev,
 libqt5svg5-dev,
 libqt5webchannel5-dev,
 libqt5x11extras5-dev,
 libtiff5-dev,
 libvorbis-dev,
 libx11-dev,
 libxtst-dev,
 libzstd-dev,
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
 qtmultimedia5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtwebengine5-dev,
 x11proto-record-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Homepage: https://github.com/xiaoyifang/goldendict
Vcs-Browser: https://salsa.debian.org/debian/goldendict-webengine
Vcs-Git: https://salsa.debian.org/debian/goldendict-webengine.git

Package: goldendict-webengine
Architecture: any
Depends:
 libjs-jquery,
 libqt5multimedia5-plugins,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 goldendict,
Replaces:
 goldendict,
Provides:
 goldendict,
Description: feature-rich dictionary lookup program (qtwebengine fork)
 GoldenDict is a feature-rich dictionary lookup program, supporting multiple
 dictionary formats (StarDict/Babylon/Lingvo/Dictd/AARD/MDict/SDict)
 and online dictionaries, featuring perfect article rendering with the
 complete markup, illustrations and other content retained,
 and allowing you to type in words without any accents or correct case.
 .
 This is a forked version that uses QtWebEngine as rendering engine instead
 of QtWebKit.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT := 5

%:
	dh $@ --buildsystem=qmake

override_dh_auto_configure:
	dh_auto_configure -- \
	        CONFIG+=chinese_conversion_support \
	        CONFIG+=zim_support \
	        PREFIX=/usr \
		goldendict.pro

execute_before_dh_auto_configure:
	ln -sf /usr/share/javascript/jquery/jquery.min.js scripts/jquery-3.6.0.slim.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js scripts/iframeResizer.contentWindow.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.js scripts/iframeResizer.min.js

## goldendict-webengine 23.02.05

=== CMakeLists.txt ===
--- 
+++ 
@@ -329,8 +329,6 @@
         history.hh
         historypanewidget.cc
         historypanewidget.hh
-        hotkeyedit.cc
-        hotkeyedit.hh
         hotkeywrapper.cc
         hotkeywrapper.hh
         htmlescape.cc
@@ -467,14 +465,15 @@
         zipfile.hh
         zipsounds.cc
         zipsounds.hh
-        )
+        src/dict/lingualibre.cpp src/dict/lingualibre.h)
 
 qt_add_executable(${CMAKE_PROJECT_NAME}
         MANUAL_FINALIZATION
         ${PROJECT_SOURCES})
 
 target_include_directories(${CMAKE_PROJECT_NAME} PUBLIC
-        ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src)
+        ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src
+        ${PROJECT_SOURCE_DIR}/src/)
 
 if(MSVC)
     add_compile_definitions(INCLUDE_LIBRARY_PATH)

=== debian/changelog ===
goldendict-webengine (23.02.05-1) unstable; urgency=medium

  * New upstream release 23.02.06-LanternFestival.230205.9b8f85ca.
  * debian/rules: Enable use_iconv flag.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Feb 2023 21:02:13 -0500

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Section: utils
 Maintainer: Boyuan Yang <byang@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends:
  debhelper-compat (= 13),
  libao-dev,

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/xiaoyifang/goldendict/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## goldendict-webengine 23.10.01

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25) # ubuntu 23.04 Fedora 36

# Qt6.4+ only

option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
option(WITH_XAPIAN "enable Xapian support" ON)
option(WITH_ZIM "enable zim support" ON)
option(WITH_TTS "enable QTexttoSpeech support" ON)

# options for linux packaging
option(USE_SYSTEM_FMT "use system fmt instead of bundled one" OFF)
option(USE_SYSTEM_TOML "use system toml++ instead of bundled one" OFF)

## Change binary & resources folder to parallel install with original GD.
## This flag should be avoided because it leads to small regressions:
## 1. There are personal scripts assuming the binary name to be "goldendict" -> require everyone to change the name in their script
## 2. There are icon themes that assuming the icon name to be "goldendict" -> invalidate the GD icon when using a icon theme
## 3. There are dictionary packages that install files to "/usr/share/goldendict/content" -> nullify the auto dict discovery
option(USE_ALTERNATIVE_NAME "Force the name goldendict-ng " OFF)

include(FeatureSummary)

project(goldendict-ng
        VERSION 23.09.08
        LANGUAGES CXX C)

if (NOT USE_ALTERNATIVE_NAME)
    set(GOLDENDICT "goldendict") # binary/executable name
else ()
    set(GOLDENDICT "goldendict-ng")
endif ()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#### Qt

find_package(Qt6 REQUIRED COMPONENTS
        Concurrent
        Core5Compat
        LinguistTools
        Multimedia
        WebEngineWidgets
        Widgets
        Svg
        Xml
        TextToSpeech
        )

qt_standard_project_setup() # availiable after find_package(Qt6 .... Core
set(CMAKE_AUTORCC ON) # not included in the qt_standard_project_setup

#### Things required during configuration

block() # generate version.txt
    string(TIMESTAMP build_time)
    find_package(Git)
    if (EXISTS "${CMAKE_SOURCE_DIR}/.git" AND GIT_FOUND)
        execute_process(
                COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_SOURCE_DIR}" rev-parse --short HEAD
                OUTPUT_STRIP_TRAILING_WHITESPACE
                OUTPUT_VARIABLE GIT_HASH)
        file(WRITE "${CMAKE_SOURCE_DIR}/version.txt" "${PROJECT_VERSION}.${GIT_HASH} at ${build_time}")
    else () # not built in a git repo
        file(WRITE "${CMAKE_SOURCE_DIR}/version.txt" "${PROJECT_VERSION} at ${build_time}")
    endif ()
endblock()

if (WIN32)
    # Binaries output dir for windows. The default ${CMAKE_BINARY_DIR} is too messy, use subfolder instead
    # So that we can directly use windeployqt inside the output folder and obtain a redistributable GD
    set(GD_WIN_OUTPUT_DIR ${CMAKE_BINARY_DIR}/${GOLDENDICT})
endif ()

#### Sources Files

# auto discovery of ui files https://cmake.org/cmake/help/v3.26/prop_tgt/AUTOUIC_SEARCH_PATHS.html
set(CMAKE_AUTOUIC_SEARCH_PATHS "${CMAKE_CURRENT_SOURCE_DIR}/src/ui/")

# https://cmake.org/cmake/help/latest/command/file.html#filesystem
# ! Using GLOB_RECURSE is not recommended by cmake's documentation
# CONFIGURE_DEPENDS will trigger file tree recheck in every rebuilds.
file(GLOB_RECURSE ALL_SOURCE_FILES CONFIGURE_DEPENDS src/*.cc src/*.hh src/*.c)

if (APPLE)
    file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/macos/*.mm)
endif ()

if (WIN32)
    set(WINDOWS_ICON_RC icons/programicon.rc)
endif ()

set(QSINGLEAPP_SOURCE_FILES
        thirdparty/qtsingleapplication/src/qtlocalpeer.cpp
        thirdparty/qtsingleapplication/src/qtlocalpeer.h
        thirdparty/qtsingleapplication/src/qtsingleapplication.cpp
        thirdparty/qtsingleapplication/src/qtsingleapplication.h
)

qt_add_executable(${GOLDENDICT})

target_sources(${GOLDENDICT} PRIVATE
        icons/flags.qrc
        resources.qrc
        src/scripts/scripts.qrc
        src/stylesheets/css.qrc
        ${ALL_SOURCE_FILES}
        ${MACOS_SOURCE_FILES}
        ${QSINGLEAPP_SOURCE_FILES}
        ${WINDOWS_ICON_RC}
)

if (NOT USE_SYSTEM_FMT)
    target_sources(${GOLDENDICT} PRIVATE thirdparty/fmt/format.cc)
endif ()

### Common parts amount all platforms

# Note: used as c++ string thus need surrounding " "
add_compile_definitions(PROGRAM_VERSION="${PROJECT_VERSION}")

target_link_libraries(${GOLDENDICT} PRIVATE
        Qt6::Xml
        Qt6::Concurrent
        Qt6::Core5Compat
        Qt6::Multimedia
        Qt6::WebEngineWidgets
        Qt6::Widgets
        Qt6::Svg
        Qt6::TextToSpeech
        )


target_include_directories(${GOLDENDICT} PRIVATE
        ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src
        ${PROJECT_SOURCE_DIR}/src/
        ${PROJECT_SOURCE_DIR}/src/common
        ${PROJECT_SOURCE_DIR}/src/dict
        ${PROJECT_SOURCE_DIR}/src/ui
        )

if (NOT USE_SYSTEM_TOML)
    target_include_directories(${GOLDENDICT} PRIVATE ${PROJECT_SOURCE_DIR}/thirdparty/tomlplusplus)
endif ()

if (NOT USE_SYSTEM_FMT)
    target_include_directories(${GOLDENDICT} PRIVATE ${PROJECT_SOURCE_DIR}/thirdparty/fmt/include)
endif ()

#### Compile definitions

target_compile_definitions(${GOLDENDICT} PUBLIC
        CMAKE_USED_HACK  # temporal hack to avoid breaking qmake build
        USE_ICONV
        MAKE_QTMULTIMEDIA_PLAYER
        MAKE_CHINESE_CONVERSION_SUPPORT
        )

if (WITH_FFMPEG_PLAYER)
    target_compile_definitions(${GOLDENDICT} PUBLIC MAKE_FFMPEG_PLAYER)
endif ()

if(NOT WITH_TTS)
    target_compile_definitions(${GOLDENDICT} PUBLIC NO_TTS_SUPPORT)
endif()


if (NOT WITH_EPWING_SUPPORT)
    target_compile_definitions(${GOLDENDICT} PUBLIC NO_EPWING_SUPPORT)
endif ()


if (WITH_XAPIAN)
    target_compile_definitions(${GOLDENDICT} PUBLIC USE_XAPIAN)
endif ()

if (WITH_ZIM)
    target_compile_definitions(${GOLDENDICT} PUBLIC MAKE_ZIM_SUPPORT)
endif ()

#### libraries linking && includes for Win or Unix

if (WIN32)
    include(CMake_Win.cmake)
else ()
    include(CMake_Unix.cmake)
endif ()

#### add translations

# include all *ts files under locale
file(GLOB TRANS_FILES "locale/*.ts")

if (WIN32)
    # Put generated files to output dir's locale
    set_source_files_properties(${TRANS_FILES} PROPERTIES OUTPUT_LOCATION "${GD_WIN_OUTPUT_DIR}/locale")
else ()
    set_source_files_properties(${TRANS_FILES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/locale")
endif ()
# a wrapper over qt_add_lupdate and  qt_add_lrelease
qt_add_translations(${GOLDENDICT} TS_FILES ${TRANS_FILES}
        QM_FILES_OUTPUT_VARIABLE qm_files)

#### installation or assemble redistribution

if (APPLE)
    set_target_properties(${GOLDENDICT} PROPERTIES
            MACOSX_BUNDLE_GUI_IDENTIFIER my.example.com
            MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
            MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
            MACOSX_BUNDLE TRUE
            )
endif ()

if (LINUX OR BSD)
    install(TARGETS ${GOLDENDICT})
    install(FILES ${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.desktop DESTINATION share/applications)
    install(FILES ${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.metainfo.xml DESTINATION share/metainfo)

    if (NOT USE_ALTERNATIVE_NAME)
        # see: config.cc -> getProgramDataDir
        add_compile_definitions(PROGRAM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/goldendict")
        install(FILES ${CMAKE_SOURCE_DIR}/redist/icons/goldendict.png DESTINATION share/pixmaps)
        install(FILES ${qm_files} DESTINATION share/goldendict/locale)
    else ()
        add_compile_definitions(PROGRAM_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/goldendict-ng")
        install(FILES ${CMAKE_SOURCE_DIR}/redist/icons/goldendict.png DESTINATION share/pixmaps
                RENAME goldendict-ng.png)
        install(FILES ${qm_files} DESTINATION share/goldendict-ng/locale)

        block() # patch the desktop file to adapt the binary & icon file's name change
            file(READ "${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.desktop" DESKTOP_FILE_CONTENT)
            string(REGEX REPLACE "\nIcon=goldendict\n" "\nIcon=goldendict-ng\n" DESKTOP_FILE_CONTENT "${DESKTOP_FILE_CONTENT}")
            string(REGEX REPLACE "\nExec=goldendict %u\n" "\nExec=goldendict-ng %u\n" DESKTOP_FILE_CONTENT "${DESKTOP_FILE_CONTENT}")
            file(WRITE "${CMAKE_SOURCE_DIR}/redist/io.github.xiaoyifang.goldendict_ng.desktop" "${DESKTOP_FILE_CONTENT}")
        endblock()
    endif ()
endif ()

if (WIN32)
    find_program(TOOL_WINDEPLOYQT NAMES windeployqt PATHS "${Qt6_ROOT}/bin")
    set_target_properties(${GOLDENDICT}
            PROPERTIES
            WIN32_EXECUTABLE TRUE
            RUNTIME_OUTPUT_DIRECTORY "${GD_WIN_OUTPUT_DIR}"
            LIBRARY_OUTPUT_DIRECTORY "${GD_WIN_OUTPUT_DIR}"
    )

    add_custom_target(windeploy
            COMMENT "Deploy everything to the output dir"
            DEPENDS ${GOLDENDICT} # build this target will check if Goldendict.exe is already built
            COMMAND ${TOOL_WINDEPLOYQT} --no-quick-import "${GD_WIN_OUTPUT_DIR}/${GOLDENDICT}.exe" --plugindir "${GD_WIN_OUTPUT_DIR}/plugins"
            COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_SOURCE_DIR}/opencc" "${GD_WIN_OUTPUT_DIR}/opencc"
            COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/LICENSE.txt" "${GD_WIN_OUTPUT_DIR}/LICENSE.txt"
            COMMAND ${CMAKE_COMMAND} -E rm -f "${GD_WIN_OUTPUT_DIR}/goldendict.exe.manifest" "${GD_WIN_OUTPUT_DIR}/eb.dll.manifest"
            WORKING_DIRECTORY ${GD_WIN_OUTPUT_DIR}
    )

    #TODO: use CPack to make the output folder as NSIS installer
endif ()

feature_summary(WHAT ALL DESCRIPTION "Build configuration:")

=== debian/changelog ===
goldendict-webengine (23.10.01-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:50:13 +1100

goldendict-webengine (23.10.01-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:30:48 +0000

goldendict-webengine (23.10.01-1build1) noble; urgency=medium

  * Rebuild against latest eb

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 14 Mar 2024 07:21:44 -0400

goldendict-webengine (23.10.01-1) unstable; urgency=medium

  * New upstream release 23.10.01-alpha.e69aabf2.
  * Branch from goldendict-ng project but keep using qmake and Qt5.

 -- Boyuan Yang <byang@debian.org>  Wed, 18 Oct 2023 14:02:22 -0400

=== debian/control ===
Source: goldendict-webengine
Priority: optional
Section: utils
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
Standards-Version: 4.6.2
Build-Depends:
 debhelper-compat (= 13),
 libavformat-dev,
 libavutil-dev,
 libbz2-dev,
 libeb16-dev,
 libfmt-dev,
 libhunspell-dev,
 libjs-jquery,
 liblzma-dev,
 liblzo2-dev,
 libopencc-dev (>= 1.1),
 libphonon4qt5-dev,
 libqt5svg5-dev,
 libqt5texttospeech5-dev,
 libqt5webchannel5-dev,
 libqt5x11extras5-dev,
 libtomlplusplus-dev,
 libvorbis-dev,
 libx11-dev,
 libxtst-dev,
 libzim-dev,
 libzstd-dev,
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
 qtmultimedia5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 qtwebengine5-dev,
 x11proto-record-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Homepage: https://github.com/xiaoyifang/goldendict-ng
Vcs-Browser: https://salsa.debian.org/debian/goldendict-ng
Vcs-Git: https://salsa.debian.org/debian/goldendict-ng.git

Package: goldendict-webengine
Architecture: any
Depends:
 libjs-jquery,
 libqt5multimedia5-plugins,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 goldendict,
 goldendict-ng,
Replaces:
 goldendict,
 goldendict-ng,
Provides:
 goldendict,
 goldendict-ng,
Description: feature-rich dictionary lookup program (NG/qtwebengine fork, Qt5)
 GoldenDict is a feature-rich dictionary lookup program, supporting multiple
 dictionary formats (StarDict/Babylon/Lingvo/Dictd/AARD/MDict/SDict)
 and online dictionaries, featuring perfect article rendering with the
 complete markup, illustrations and other content retained,
 and allowing you to type in words without any accents or correct case.
 .
 This is a forked version that uses QtWebEngine as rendering engine instead
 of QtWebKit. This package uses Qt5 as UI framework.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT := 5

%:
	dh $@ --buildsystem=qmake

override_dh_auto_configure:
	dh_auto_configure -- \
	        CONFIG+=chinese_conversion_support \
	        CONFIG+=zim_support \
	        CONFIG+=use_iconv \
	        PREFIX=/usr \
		goldendict.pro

execute_before_dh_auto_configure:
	# Use unminified javascript sources
	ln -sf /usr/share/javascript/jquery/jquery.min.js src/scripts/jquery-3.6.0.slim.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js
	cp debian/missing-sources/popper.js src/scripts/popper.min.js
	cp debian/missing-sources/tippy-bundle.umd.js src/scripts/tippy.min.js

=== debian/watch ===
version=4
opts="repack,filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/xiaoyifang/goldendict-ng/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## goldendict-webengine 24.02.16

=== debian/changelog ===
goldendict-webengine (24.02.16-1) unstable; urgency=medium

  * New upstream tag v24.02.16-alpha.fbe5335e.
  * Sync with goldendict-ng 24.02.16-1 upload, keep Qt5.

 -- Boyuan Yang <byang@debian.org>  Thu, 11 Apr 2024 23:22:34 -0400

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,4 @@
 	ln -sf /usr/share/javascript/jquery/jquery.min.js src/scripts/jquery-3.6.0.slim.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.contentWindow.js src/scripts/iframeResizer.contentWindow.min.js
 	cp debian/missing-sources/iframe-resizer/iframeResizer.js src/scripts/iframeResizer.min.js
-	cp debian/missing-sources/popper.js src/scripts/popper.min.js
-	cp debian/missing-sources/tippy-bundle.umd.js src/scripts/tippy.min.js

## goldendict-webengine 24.05.05

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,6 @@
 
 option(WITH_FFMPEG_PLAYER "Enable support for FFMPEG player" ON)
 option(WITH_EPWING_SUPPORT "Enable epwing support" ON)
-option(WITH_XAPIAN "enable Xapian support" ON)
 option(WITH_ZIM "enable zim support" ON)
 option(WITH_TTS "enable QTexttoSpeech support" ON)
 
@@ -22,31 +21,29 @@
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 23.09.08
+        VERSION 24.05.05
         LANGUAGES CXX C)
 
-if (NOT USE_ALTERNATIVE_NAME)
-    set(GOLDENDICT "goldendict") # binary/executable name
-else ()
+set(GOLDENDICT "goldendict") # binary/executable name
+if (USE_ALTERNATIVE_NAME )
     set(GOLDENDICT "goldendict-ng")
 endif ()
+if (APPLE)
+    set(GOLDENDICT "GoldenDict-ng")
+endif()
 
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 #### Qt
 
-find_package(Qt6 REQUIRED COMPONENTS
-        Concurrent
-        Core5Compat
-        LinguistTools
-        Multimedia
-        WebEngineWidgets
-        Widgets
-        Svg
-        Xml
-        TextToSpeech
-        )
+set(GD_QT_COMPONENTS Concurrent Core5Compat LinguistTools Multimedia PrintSupport WebEngineWidgets Widgets Svg Xml)
+
+if (WITH_TTS)
+    list(APPEND GD_QT_COMPONENTS TextToSpeech)
+endif ()
+
+find_package(Qt6 REQUIRED COMPONENTS ${GD_QT_COMPONENTS})
 
 qt_standard_project_setup() # availiable after find_package(Qt6 .... Core
 set(CMAKE_AUTORCC ON) # not included in the qt_standard_project_setup
@@ -54,7 +51,7 @@
 #### Things required during configuration
 
 block() # generate version.txt
-    string(TIMESTAMP build_time)
+    string(TIMESTAMP build_time UTC)
     find_package(Git)
     if (EXISTS "${CMAKE_SOURCE_DIR}/.git" AND GIT_FOUND)
         execute_process(
@@ -85,6 +82,9 @@
 
 if (APPLE)
     file(GLOB_RECURSE MACOS_SOURCE_FILES CONFIGURE_DEPENDS src/macos/*.mm)
+
+    set(MACOS_APP_ICON ${CMAKE_SOURCE_DIR}/icons/macicon.icns)
+    set_source_files_properties(${MACOS_APP_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
 endif ()
 
 if (WIN32)
@@ -107,6 +107,7 @@
         src/stylesheets/css.qrc
         ${ALL_SOURCE_FILES}
         ${MACOS_SOURCE_FILES}
+        ${MACOS_APP_ICON}
         ${QSINGLEAPP_SOURCE_FILES}
         ${WINDOWS_ICON_RC}
 )
@@ -125,12 +126,15 @@
         Qt6::Concurrent
         Qt6::Core5Compat
         Qt6::Multimedia
+        Qt6::PrintSupport
         Qt6::WebEngineWidgets
         Qt6::Widgets
         Qt6::Svg
-        Qt6::TextToSpeech
         )
 
+if (WITH_TTS)
+    target_link_libraries(${GOLDENDICT} PRIVATE Qt6::TextToSpeech)
+endif ()
 
 target_include_directories(${GOLDENDICT} PRIVATE
         ${PROJECT_SOURCE_DIR}/thirdparty/qtsingleapplication/src
@@ -170,11 +174,6 @@
     target_compile_definitions(${GOLDENDICT} PUBLIC NO_EPWING_SUPPORT)
 endif ()
 
-
-if (WITH_XAPIAN)
-    target_compile_definitions(${GOLDENDICT} PUBLIC USE_XAPIAN)
-endif ()
-
 if (WITH_ZIM)
     target_compile_definitions(${GOLDENDICT} PUBLIC MAKE_ZIM_SUPPORT)
 endif ()
@@ -205,12 +204,53 @@
 #### installation or assemble redistribution
 
 if (APPLE)
+    set(PLIST_FILE "${CMAKE_BINARY_DIR}/info_generated.plist")
+    configure_file("${CMAKE_SOURCE_DIR}/redist/mac_info_plist_template_cmake.plist" "${PLIST_FILE}" @ONLY)
+
     set_target_properties(${GOLDENDICT} PROPERTIES
-            MACOSX_BUNDLE_GUI_IDENTIFIER my.example.com
-            MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
-            MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
             MACOSX_BUNDLE TRUE
-            )
+            MACOSX_BUNDLE_INFO_PLIST "${PLIST_FILE}"
+    )
+
+    set(Assembling_Dir "${CMAKE_BINARY_DIR}/redist")
+    set(App_Name "${GOLDENDICT}.app")
+    set(Redistributable_APP "${Assembling_Dir}/${App_Name}")
+    
+    qt_generate_deploy_script(
+            TARGET ${GOLDENDICT}
+            OUTPUT_SCRIPT deploy_script
+            CONTENT "qt_deploy_runtime_dependencies(
+                        EXECUTABLE \"${Redistributable_APP}\"
+                        GENERATE_QT_CONF
+                        NO_APP_STORE_COMPLIANCE
+                )"
+    )
+
+    install(TARGETS ${GOLDENDICT} BUNDLE DESTINATION "${Assembling_Dir}")
+    install(FILES ${qm_files} DESTINATION "${Redistributable_APP}/Contents/MacOS/locale")
+    install(DIRECTORY "${CMAKE_SOURCE_DIR}/opencc" DESTINATION "${Redistributable_APP}/Contents/MacOS")
+
+    install(SCRIPT ${deploy_script})
+
+    install(CODE "execute_process(COMMAND codesign --force --deep -s - ${Redistributable_APP})")
+
+    find_program(CREATE-DMG "create-dmg")
+    if (CREATE-DMG)
+        install(CODE "
+        execute_process(COMMAND ${CREATE-DMG} \
+            --skip-jenkins \
+            --format \"ULMO\"
+            --volname ${CMAKE_PROJECT_NAME}-${CMAKE_PROJECT_VERSION}-${CMAKE_SYSTEM_PROCESSOR} \
+            --volicon ${CMAKE_SOURCE_DIR}/icons/macicon.icns \
+            --icon \"${App_Name}\" 100 100
+            --app-drop-link 300 100 \
+            \"GoldenDict-${CMAKE_PROJECT_VERSION}-Qt${Qt6_VERSION}-${CMAKE_SYSTEM_PROCESSOR}.dmg\" \
+            \"${Assembling_Dir}\")"
+        )
+    else ()
+        message(WARNING "create-dmg not found. No .dmg will be created")
+    endif ()
+
 endif ()
 
 if (LINUX OR BSD)
@@ -239,7 +279,6 @@
 endif ()
 
 if (WIN32)
-    find_program(TOOL_WINDEPLOYQT NAMES windeployqt PATHS "${Qt6_ROOT}/bin")
     set_target_properties(${GOLDENDICT}
             PROPERTIES
             WIN32_EXECUTABLE TRUE
@@ -250,14 +289,24 @@
     add_custom_target(windeploy
             COMMENT "Deploy everything to the output dir"
             DEPENDS ${GOLDENDICT} # build this target will check if Goldendict.exe is already built
-            COMMAND ${TOOL_WINDEPLOYQT} --no-quick-import "${GD_WIN_OUTPUT_DIR}/${GOLDENDICT}.exe" --plugindir "${GD_WIN_OUTPUT_DIR}/plugins"
+            COMMAND ${WINDEPLOYQT_EXECUTABLE} --no-quick-import "${GD_WIN_OUTPUT_DIR}/${GOLDENDICT}.exe" --plugindir "${GD_WIN_OUTPUT_DIR}/plugins"
             COMMAND ${CMAKE_COMMAND} -E copy_directory "${CMAKE_SOURCE_DIR}/opencc" "${GD_WIN_OUTPUT_DIR}/opencc"
             COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_SOURCE_DIR}/LICENSE.txt" "${GD_WIN_OUTPUT_DIR}/LICENSE.txt"
             COMMAND ${CMAKE_COMMAND} -E rm -f "${GD_WIN_OUTPUT_DIR}/goldendict.exe.manifest" "${GD_WIN_OUTPUT_DIR}/eb.dll.manifest"
             WORKING_DIRECTORY ${GD_WIN_OUTPUT_DIR}
     )
 
-    #TODO: use CPack to make the output folder as NSIS installer
+    # use CPack to make the output folder as NSIS installer
+    install(
+        DIRECTORY "${GD_WIN_OUTPUT_DIR}/"
+        DESTINATION .
+    )
+
+    set(CPACK_PACKAGE_FILE_NAME "${Qt6Widgets_VERSION}-${PROJECT_NAME}-${PROJECT_VERSION}-${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
+    set(CPACK_GENERATOR "7Z;NSIS")
+    set(CPACK_NSIS_MANIFEST_DPI_AWARE ON)
+    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt")
+    include(CPack)
 endif ()
 
 feature_summary(WHAT ALL DESCRIPTION "Build configuration:")

=== debian/changelog ===
goldendict-webengine (24.05.05-1) unstable; urgency=medium

  * New upstream tag 24.05.05-LiXia.ecd1138c.

 -- Boyuan Yang <byang@debian.org>  Mon, 06 May 2024 23:43:43 -0400

## goldendict-webengine 24.05.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 include(FeatureSummary)
 
 project(goldendict-ng
-        VERSION 24.05.05
+        VERSION 24.05.13
         LANGUAGES CXX C)
 
 set(GOLDENDICT "goldendict") # binary/executable name

=== debian/changelog ===
goldendict-webengine (24.05.13-1) unstable; urgency=medium

  * New upstream tag 24.05.13-alpha.2e88e3b2.
  * debian/patches/backport/e2e1ca...patch: Apply upstream patch to
    fix compilation against ffmpeg 7.0. (Closes: #1072416)

 -- Boyuan Yang <byang@debian.org>  Mon, 10 Jun 2024 14:41:57 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: goldendict-webengine
 Priority: optional
 Section: utils
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Boyuan Yang <byang@debian.org>
+Maintainer: Boyuan Yang <byang@debian.org>
 Standards-Version: 4.6.2
 Build-Depends:
  debhelper-compat (= 13),
@@ -27,7 +26,7 @@
  libxtst-dev,
  libzim-dev,
  libzstd-dev,
- pkg-config,
+ pkgconf,
  qt5-qmake,
  qtbase5-dev,
  qtmultimedia5-dev,

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,9 @@
 
 %:
 	dh $@ --buildsystem=qmake
+
+execute_after_dh_clean:
+	rm -fv src/scripts/jquery-3.6.0.slim.min.js
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
